import request from '@/utils/request';
import type {ApiResult, PageResult} from '@/api';
import type {Customer, CustomerParam} from './model';

/**
 * 分页查询客户
 */
export async function pageCustomer(params: CustomerParam) {
  const res = await request.get<ApiResult<PageResult<Customer>>>(
    '/tower/tower-customer/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询客户列表
 */
export async function listCustomer(params?: CustomerParam) {
  const res = await request.get<ApiResult<Customer[]>>(
    '/tower/tower-customer',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询客户
 */
export async function getCustomer(id: number) {
  const res = await request.get<ApiResult<Customer>>(
    '/tower/tower-customer/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加客户
 */
export async function addCustomer(data: Customer) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-customer',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改客户
 */
export async function updateCustomer(data: Customer) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-customer',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量添加客户
 */
export async function addBatchCustomer(data: Customer[]) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-customer/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量修改客户
 */
export async function updateBatchCustomer(data: Customer[]) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-customer/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除客户
 */
export async function removeCustomer(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-customer/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除客户
 */
export async function removeBatchCustomer(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-customer/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    '/tower/tower-customer/existence',
    {
      params: {field, value, id}
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
